VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Waves"
   ClientHeight    =   8235
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   7275
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   549
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   485
   StartUpPosition =   3  'Windows Default
   Begin VB.HScrollBar HScroll2 
      Height          =   255
      Left            =   240
      Max             =   100
      Min             =   2
      TabIndex        =   12
      Top             =   7920
      Value           =   20
      Width           =   2535
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Wall Toggle"
      Height          =   495
      Left            =   4920
      TabIndex        =   11
      Top             =   7320
      Width           =   1095
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Optimisations"
      Enabled         =   0   'False
      Height          =   255
      Left            =   2880
      TabIndex        =   10
      Top             =   7320
      Value           =   1  'Checked
      Width           =   1815
   End
   Begin VB.CommandButton Command1 
      Caption         =   "RESET"
      Height          =   495
      Left            =   6120
      TabIndex        =   8
      Top             =   7320
      Width           =   975
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Rain"
      Height          =   255
      Left            =   2880
      TabIndex        =   7
      Top             =   7560
      Width           =   1815
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   240
      Max             =   100
      Min             =   1
      TabIndex        =   3
      Top             =   7440
      Value           =   1
      Width           =   2535
   End
   Begin VB.PictureBox Picture3 
      Height          =   5985
      Left            =   6360
      ScaleHeight     =   395
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   46
      TabIndex        =   2
      Top             =   240
      Width           =   750
   End
   Begin VB.PictureBox Picture2 
      Height          =   750
      Left            =   240
      ScaleHeight     =   46
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   395
      TabIndex        =   1
      Top             =   6360
      Width           =   5985
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   3480
      Top             =   6240
   End
   Begin VB.PictureBox Picture1 
      Height          =   6000
      Left            =   240
      ScaleHeight     =   396
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   396
      TabIndex        =   0
      Top             =   240
      Width           =   6000
   End
   Begin VB.PictureBox Picture4 
      AutoRedraw      =   -1  'True
      Height          =   6000
      Left            =   120
      ScaleHeight     =   396
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   396
      TabIndex        =   6
      Top             =   360
      Visible         =   0   'False
      Width           =   6000
   End
   Begin VB.Label Label4 
      Caption         =   "Distortion:"
      Height          =   255
      Left            =   240
      TabIndex        =   13
      Top             =   7680
      Width           =   1095
   End
   Begin VB.Label Label3 
      Height          =   255
      Left            =   6240
      TabIndex        =   9
      Top             =   6840
      Width           =   1335
   End
   Begin VB.Label Label2 
      Height          =   495
      Left            =   6240
      TabIndex        =   5
      Top             =   6360
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Viscosity:"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   7200
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const acceleration = 1
Const maxAlt = 100

'bounds of the image space
Const boundLeft = 0
Const boundRight = 399
Const boundUp = 0
Const boundDown = 399
Const boundWidth = boundRight - boundLeft + 1
Const boundHeight = boundDown - boundUp + 1

'bounds of simulation space
Const simLeft = 0
Const simRight = 79
Const simUp = 0
Const simDown = 79
Const simWidth = simRight - simLeft + 1
Const simHeight = simUp - simDown + 1

'ratio of image space to sim space
Const ISRatio = 5
Const inv_ISRatio = 0.2

'extra allowance on borders of both sim and image space to save on array bounds checks
Const softSelect = 2

Dim damping As Single
Const springK = 0.025

Const refractIndex = 1.5
Dim heightClamp As Integer 'higher value scales down the height map before applying it

'simulation space
Dim simPt(simLeft - softSelect To simRight + softSelect, simUp - softSelect To simDown + softSelect) As node_t

'image space
Dim pt(boundLeft - softSelect To boundRight + softSelect, boundUp - softSelect To boundDown + softSelect) As node_t
'Dim image1(boundLeft To boundRight, boundUp To boundDown) As Long
Dim image1r(boundLeft To boundRight, boundUp To boundDown) As Integer
Dim image1g(boundLeft To boundRight, boundUp To boundDown) As Integer
Dim image1b(boundLeft To boundRight, boundUp To boundDown) As Integer

Dim isMDown As Boolean
Dim drawWall As Boolean
Dim cxOld As Integer, cyOld As Integer
Dim cypos As Integer, cxpos As Integer
Dim optimised As Boolean

Private Declare Function GetTickCount Lib "kernel32" () As Long

Sub initMesh()
    Dim i As Integer, j As Integer
    For i = simLeft To simRight
        For j = simUp To simDown
            simPt(i, j).vel = 0
            simPt(i, j).alt = 0
            simPt(i, j).token = 1
        Next
    Next
End Sub

Sub loadImg(str As String)
Dim k1 As Integer, k2 As Integer
Picture4.Picture = LoadPicture(str)
Picture4.Refresh
For k1 = boundLeft To boundRight
    For k2 = boundUp To boundDown
         
        image1r(k1, k2) = Picture4.Point(k1, k2) Mod 256
        image1g(k1, k2) = ((Picture4.Point(k1, k2) - image1r(k1, k2)) / 256) Mod 256
        image1b(k1, k2) = (((Picture4.Point(k1, k2) - image1r(k1, k2)) / 256) - image1g(k1, k2)) / 256
        'image1(k1, k2) = Picture4.Point(k1, k2)
    Next k2
Next k1
End Sub

Function minVal(ByVal a As Integer, ByVal b As Integer) As Integer
    minVal = IIf(a > b, b, a)
End Function

Function maxVal(ByVal a As Integer, ByVal b As Integer) As Integer
    maxVal = IIf(a > b, a, b)
End Function

Sub moveNode(x As Integer, y As Integer, disp As Single)
Static dispVal As Single

If (x < boundLeft Or x > boundRight Or y < boundUp Or y > boundDown) Then Exit Sub

With simPt(x, y)

    If .wall = True Then Exit Sub
    
    dispVal = Abs(disp)
    If dispVal > 1 Then
        .token = 1
    ElseIf .token > 4 And dispVal > 0.1 Then
        .token = 4
    ElseIf .token > 16 And dispVal > 0.05 Then
        .token = 16
    ElseIf .token > 32 And dispVal > 0.01 Then
        .token = 32
    Else
        .token = 0
    End If
    
    .alt = .alt + disp
    If .alt > maxAlt Then
        .alt = maxAlt
    ElseIf .alt < -maxAlt Then
        .alt = -maxAlt
    End If

End With

End Sub

Sub getNewVelocity(i As Integer, j As Integer)
    Static acc1 As Single
    Static acc2 As Single
    If simPt(i, j).wall = True Then Exit Sub

    acc1 = simPt(i - 1, j - 1).alt + simPt(i, j - 1).alt + _
        simPt(i + 1, j - 1).alt + simPt(i - 1, j).alt + simPt(i + 1, j).alt + _
        simPt(i - 1, j + 1).alt + simPt(i, j + 1).alt + simPt(i + 1, j + 1).alt
        
    'If (acc1 > 20) Then
     '   acc2 = pt(i - 2, j - 2).alt + pt(i - 2, j - 1).alt + pt(i - 2, j).alt + pt(i - 2, j + 1).alt + pt(i - 2, j + 2).alt + _
     '       pt(i - 1, j - 2).alt + pt(i - 1, j + 2).alt + pt(i, j - 2).alt + pt(i, j + 2).alt + pt(i + 1, j - 2).alt + pt(i + 1, j + 2).alt + _
     '       pt(i + 2, j - 2).alt + pt(i + 2, j - 1).alt + pt(i + 2, j).alt + pt(i + 2, j + 1).alt + pt(i + 2, j + 2).alt
    'Else
    '    acc2 = 0
    'End If
    
    With simPt(i, j)
        .vel = .vel + (acc1 + acc2 * 0.1) * springK - .alt / 4  'acc2 '
        .vel = .vel * damping
    End With
End Sub

Sub simulateMesh()
    Dim i As Integer, j As Integer

    For i = simLeft + 1 To simRight - 1
        For j = simUp + 1 To simDown - 1
            getNewVelocity i, j
        Next
    Next
    For i = simLeft + 1 To simRight - 1
        For j = simUp + 1 To simDown - 1
            moveNode i, j, simPt(i, j).vel
        Next
    Next
    
    interpolate
End Sub

Sub interpolate()
    Static i As Integer, j As Integer
    Static x0 As Integer, y0 As Integer
    Static a As Single, a1 As Single, b As Single, b1 As Single
    Static p As Integer, q As Integer
    Static token4 As Integer
    
    Static nw As Single, ne As Single, sw As Single, se As Single
    
    
    For i = simLeft To simRight
    For j = simUp To simDown
        x0 = i * ISRatio
        y0 = j * ISRatio
        a = 0
        a1 = 1

        se = simPt(i, j).alt
        ne = simPt(i, j + 1).alt
        sw = simPt(i + 1, j).alt
        nw = simPt(i + 1, j + 1).alt
        token4 = (simPt(i, j).token + simPt(i + 1, j).token + simPt(i, j + 1).token + simPt(i + 1, j + 1).token) / 4
        
        For p = 0 To ISRatio - 1
            b = 0
            b1 = 1
            For q = 0 To ISRatio - 1
                pt(x0 + p, y0 + q).alt = (a * (b * nw + b1 * sw)) + (a1 * (b * ne + b1 * se))
                b = b + inv_ISRatio
                b1 = 1 - b
                If pt(x0 + p, y0 + q).token = 0 Then pt(x0 + p, y0 + q).token = token4
            Next q
            a = a + inv_ISRatio
            a1 = 1 - a
        Next p
    Next j
    Next i
End Sub

Sub drawMesh(Optional forceRefresh As Boolean = False)
Static i As Integer, j As Integer
Static p As Integer, q As Integer
Static r As Integer, g As Integer, b As Integer

Static dx  As Integer, dy As Integer
Static nx As Integer, ny As Integer
Static deltaVal As Integer
Static drawCount As Long

drawCount = 0

glBegin GL_POINTS

    For p = simLeft To simRight - 1
    For q = simUp To simDown - 1
        
        If forceRefresh Or simPt(p, q).token = 1 Or _
            simPt(p + 1, q).token = 1 Or simPt(p, q + 1).token = 1 Or _
            simPt(p + 1, q + 1).token = 1 Then
        
            drawCount = drawCount + 1
            
            For i = p * ISRatio To (p + 1) * ISRatio - 1
            For j = q * ISRatio To (q + 1) * ISRatio - 1
            With pt(i, j)
                'dx = (pt(i + 1, j).alt - .alt) / 2
                'dy = (pt(i, j + 1).alt - .alt) / 2
                'deltaVal = (pt(i, j).alt * 90 / maxAlt) 'dx + dy
                Dim brite As Double
                getDxDy i, j, dx, dy, brite
                deltaVal = brite

                nx = dx + i
                ny = dy + j
                      
                If (nx < boundLeft Or nx > boundRight) Then nx = i
                If (ny < boundUp Or ny > boundDown) Then ny = j
                
                r = deltaVal + image1r(nx, ny)
                g = deltaVal + image1g(nx, ny)
                b = deltaVal + image1b(nx, ny)
                
                glColor3f r / 256, g / 256, b / 256
                glVertex2f (2 * i / boundWidth) - 1, 1 - (2 * j / boundHeight)
        
            End With
            Next j
            Next i
        
        End If
        
        If simPt(p, q).token > 0 Then simPt(p, q).token = simPt(p, q).token - 1
    Next q
    Next p
glEnd
    SwapBuffers Picture1.hDC
    Label3.Caption = drawCount * ISRatio * ISRatio
End Sub

Sub getDxDy(i As Integer, j As Integer, ByRef dxRet As Integer, ByRef dyRet As Integer, ByRef bright As Double)
Dim tmpX As Integer, tmpY As Integer
Dim theta1 As Double, theta2 As Double
Const brightXplier = 50

tmpX = pt(i + 1, j).alt - pt(i - 1, j).alt
tmpY = pt(i, j + 1).alt - pt(i, j - 1).alt

theta2 = Atn(tmpY / heightClamp)
theta1 = Atn(tmpX / heightClamp)

bright = Sin(theta2) * brightXplier

dxRet = pt(i, j).alt * Tan(theta1 - ASin(refractIndex * Sin(theta1)))
dyRet = pt(i, j).alt * Tan(theta2 - ASin(refractIndex * Sin(theta2)))

End Sub

'Sub SetPixel2(x As Integer, y As Integer, r As Integer, g As Integer, b As Integer)
'glColor3f CSng(r) / 256, CSng(g) / 256, CSng(b) / 256
'glVertex2f (2 * x / boundWidth) - 1, 1 - (2 * y / boundHeight)
'End Sub


Private Sub Check2_Click()
optimised = Check2.value
End Sub

Private Sub Command1_Click()
Dim i As Integer, j As Integer
For i = boundLeft To boundRight
    For j = boundUp To boundDown
        pt(i, j).alt = 0
        pt(i, j).vel = 0
        pt(i, j).wall = False
    Next j
Next i
For i = simLeft To simRight
    For j = simUp To simDown
        simPt(i, j).alt = 0
        simPt(i, j).vel = 0
        simPt(i, j).token = 1
        simPt(i, j).wall = False
    Next j
Next i

End Sub

Private Sub Command2_Click()
drawWall = Not drawWall
End Sub

Private Sub Form_Load()
cxpos = 0
cypos = 0
cxOld = -10
cyOld = -10
Me.Caption = "Loading image..."
loadImg "tmp400.bmp"
damping = 99 / 100
heightClamp = 20
Me.Caption = "Initialising OpenGL..."
Me.Show

optimised = True
EnableOpenGL Picture1.hDC
glClearColor 32 / 256, 64 / 256, 128 / 256, 1     'background
Me.Caption = "Waves"

initMesh
Timer1.Enabled = True
'initRefreshCount = 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
DisableOpenGL
End Sub

Private Sub HScroll1_Change()
damping = (100 - HScroll1.value) / 100
End Sub

Private Sub HScroll2_Change()
heightClamp = HScroll2.value
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

isMDown = True
disturb Int(x), Int(y)
End Sub

Sub disturb(ByVal x As Integer, ByVal y As Integer)

x = x * inv_ISRatio
y = y * inv_ISRatio

If drawWall = True Then
    If x > boundLeft And x < boundRight And y > boundUp And y < boundDown Then
        simPt(x, y).wall = True
    End If
    Exit Sub
End If

Const c0 = -100
Const c1 = -80
Const c2 = -60

moveNode x, y, c0

moveNode x + 1, y, c1
moveNode x, y + 1, c1
moveNode x - 1, y, c1
moveNode x, y - 1, c1

moveNode x - 1, y - 1, c2
moveNode x - 1, y + 1, c2
moveNode x + 1, y - 1, c2
moveNode x + 1, y + 1, c2

End Sub

Sub drawLine(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer)
Dim slope As Single
Dim flip As Boolean
Dim tmp As Integer
Dim cx As Integer, cy As Single

'ensure that |slope|<=1
If Abs(x2 - x1) < Abs(y2 - y1) Then
    tmp = x1
    x1 = y1
    y1 = tmp
    tmp = x2
    x2 = y2
    y2 = tmp
    flip = True
End If

'calculate slope
If x1 <> x2 Then
    slope = (y2 - y1) / (x2 - x1)
Else
    slope = 0
End If

'ensure that x2>=x1
If x2 < x1 Then
    tmp = x1
    x1 = x2
    x2 = tmp
    tmp = y1
    y1 = y2
    y2 = tmp
End If

'initialise cx and cy
cx = x1
cy = y1

'algorithm
While (cx <= x2)

    'plot point
    If flip Then
        disturb Int(cy), cx
    Else
        disturb cx, Int(cy)
    End If
    cx = cx + 1
    cy = cy + slope
Wend

End Sub


Sub drawgraph()
Dim i As Integer, j As Integer
Picture2.Cls
Picture3.Cls
For i = boundLeft To boundRight
    SetPixel Picture2.hDC, i, 25 + (pt(i, cypos).alt * 25 / maxAlt), vbBlack
Next
For i = boundUp To boundDown
    SetPixel Picture3.hDC, 25 + (pt(cxpos, i).alt * 25 / maxAlt), i, vbBlack
Next i
End Sub

Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
cypos = y
cxpos = x
cxpos = maxVal(cxpos, boundLeft)
cxpos = minVal(cxpos, boundRight)
cypos = maxVal(cypos, boundUp)
cypos = minVal(cypos, boundDown)

If (cxOld < 0) Then
    cxOld = cxpos
    cyOld = cypos
End If

If isMDown = True Then
    drawLine cxOld, cyOld, cxpos, cypos
    'disturb Int(x), Int(y)
End If

cxOld = cxpos
cyOld = cypos
End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
isMDown = False
End Sub

Private Sub Timer1_Timer()
Static nowTime As Long
nowTime = GetTickCount()
'If initRefreshCount > 0 Then
'    initRefreshCount = initRefreshCount - 1
'    drawMesh True
'Else
    drawMesh False
'End If
Label2.Caption = "D: " & GetTickCount() - nowTime & vbNewLine
nowTime = GetTickCount()
'simulateMesh
simulateMesh
Label2.Caption = Label2.Caption & "S: " & GetTickCount() - nowTime
drawgraph
If Check1.value = vbChecked Then
    disturb Rnd() * boundWidth + boundLeft, Rnd() * boundHeight + boundUp
    disturb Rnd() * boundWidth + boundLeft, Rnd() * boundHeight + boundUp
    disturb Rnd() * boundWidth + boundLeft, Rnd() * boundHeight + boundUp
    disturb Rnd() * boundWidth + boundLeft, Rnd() * boundHeight + boundUp
End If
End Sub


'"true" arc tangent function copied from vb-helper.com
Public Function Atn2(ByVal y As Double, ByVal x As Double) _
    As Double
  Dim theta As Double

  If (Abs(x) < 0.0000001) Then
    If (Abs(y) < 0.0000001) Then
      theta = 0#
    ElseIf (y > 0#) Then
      theta = 1.5707963267949
    Else
      theta = -1.5707963267949
    End If
  Else
    theta = Atn(y / x)
  
    If (x < 0) Then
      If (y >= 0#) Then
        theta = 3.14159265358979 + theta
      Else
        theta = theta - 3.14159265358979
      End If
    End If
  End If
    
  Atn2 = theta
End Function

'arcsine function from devx.com
Function ASin(value As Double) As Double
    
    If Abs(value) <> 1 Then
        ASin = Atn(value / Sqr(Abs(1 - value * value)))
    Else
        ASin = 1.5707963267949 * Sgn(value)
    End If
End Function
